#pragma once
#include "resummationQCD.hh"

using namespace std;

namespace resumm {

  class debugResummation: public QCDResummation {


  public:

    debugResummation(process p, collider c, string PDFset, int PDFmember=0): QCDResummation(p, c, PDFset, PDFmember) {}
    debugResummation(QCDResummation res): QCDResummation(res) {}
    ~debugResummation();

    dcomplex Ug0expS_matched(dcomplex N);
    dcomplex ULuminosityN(dcomplex N);
    double Lumintau();
    double Lumintau(double M, double sqrts);
    double LuminxDIS(double x, double Q, double y=0, double TM=0, double mcoQ=0);

    double FOapprox_xs(double m, double sqrt_s, double muF_m_ratio, double muR_m_ratio, log_order LOGo, order order, double *asinput=NULL);
    double FOapprox_xs_rap(double m, double Y, double sqrt_s, double muF_m_ratio, double muR_m_ratio, log_order LOGo, order order, double *asinput=NULL);


    double N0_of_tau();

    double lum_times_g0expS_matched_der(double N);
    double lum_times_g0expS_matched_der2(double N);
    double LumN_der(double N);
    double LumN_der2(double N);

    double derivative_exponent(double N);

    double LumN(double N);

    double res_xs_of_N0(double m, double sqrt_s,double muF_m_ratio, double muR_m_ratio, log_order LOGo, order match_order, double *asinput);


  private:

    dcomplex g0expS_expanded_predamping(dcomplex N, order o);
    dcomplex g0expS_expanded_presubtraction(dcomplex N, order o);
    dcomplex g0expS_expanded(dcomplex N, order o);
    dcomplex lum_times_g0expS_expanded(dcomplex N, order o);
    friend double FOapprox_integrand(double t, void *p);
    double FOapprox();
    //


  };

};



